local AppName = ...
local L = LibStub("AceLocale-3.0"):GetLocale(AppName)
BeemoHelper=LibStub("AceAddon-3.0"):NewAddon("BeemoHelper", "AceConsole-3.0","AceEvent-3.0","AceTimer-3.0")
BeemoHelper.Active=false
BeemoHelper.Debug=false
--BeemoHelper:UnregisterAllEvents()

local function DPrint(...)
	if BeemoHelper.Debug then
		print(...)
	end
end
local spellRankTableData = {
	[1] = { 774, 8936, 5185, 740, 635, 19750, 139, 2060, 596, 2061, 2054, 2050, 1064, 331, 8004, 136, 755, 689, 746 },
	[2] = { 1058, 8938, 5186, 8918, 639, 19939, 6074, 10963, 996, 9472, 2055, 2052, 10622, 332, 8008, 3111, 3698, 699, 1159 },
	[3] = { 1430, 8939, 5187, 9862, 647, 19940, 6075, 10964, 10960, 9473, 6063, 2053, 10623, 547, 8010, 3661, 3699, 709, 3267 },
	[4] = { 2090, 8940, 5188, 9863, 1026, 19941, 6076, 10965, 10961, 9474, 6064, 913, 10466, 3662, 3700, 7651, 3268 },
	[5] = { 2091, 8941, 5189, 1042, 19942, 6077, 22009, 25314, 25316, 10915, 939, 10467, 13542, 11693, 11699, 7926 },
	[6] = { 3627, 9750, 6778, 3472, 19943, 6078, 10916, 959, 10468, 13543, 11694, 11700, 7927, 23569, 24412 },
	[7] = { 8910, 9856, 8903, 10328, 10927, 10917, 8005, 13544, 11695, 10838 },
	[8] = { 9839, 9857, 9758, 10329, 10928, 10395, 10839, 23568, 24413 },
	[9] = { 9840, 9858, 9888, 25292, 10929, 10396, 18608 },
	[10] = { 9841, 9889, 25315, 25357, 18610, 23567, 24414 },
	[11] = { 25299, 25297, 30020 },
}

local function make_class_prefix(classid)
  local classid2color={"|cFFC79C6E","|cFFF58CBA","|cFFA9D271","|cFFFFF569","|cFFFFFFFF","|cFFC41F3B","|cFF0070DE","|cFF40C7EB","|cFF8787ED","|cFF00FF96","|cFFFF7D0A","|cFFA330C9"}
  return classid2color[classid]
end

local SpellIDToRank = {}
for rankIndex, spellIDTable in pairs(spellRankTableData) do
	for _, spellID in pairs(spellIDTable) do
		SpellIDToRank[spellID] = rankIndex
	end
end


function BeemoHelper:BuildFrame()
	
--heal frame
	local texture_str = "Interface\\TARGETINGFRAME\\UI-StatusBar"
	if not BeemoHelperFrame then
		BeemoHelperFrame=CreateFrame("Button", "myMacroButton", UIParent, "SecureActionButtonTemplate")
		BeemoHelperFrame:SetAttribute("type", "macro") -- left click causes macro
		
		BeemoHelperFrame.bg = BeemoHelperFrame:CreateTexture(nil,"BACKGROUND", nil, -5)
		BeemoHelperFrame.bg:SetTexture(texture_str)
		BeemoHelperFrame.bg:SetVertexColor(0,0.1,0,0.8)
		BeemoHelperFrame.bg:SetAllPoints(BeemoHelperFrame)
		print(L["HelpTips"])
		BeemoHelperFrame:SetAttribute("macrotext1",'/script print("'..L["HelpTips"]..'")') 
		BeemoHelperFrame:SetMovable(true)
		BeemoHelperFrame:SetSize(100,60)
		BeemoHelperFrame:SetPoint("TOPLEFT",0,-10)
		BeemoHelperFrame:EnableMouse(true)
		BeemoHelperFrame:RegisterForDrag("RightButton")
		BeemoHelperFrame:SetScript("OnDragStart", BeemoHelperFrame.StartMoving)
		BeemoHelperFrame:SetScript("OnDragStop", BeemoHelperFrame.StopMovingOrSizing)
		BeemoHelperFrame.HPTip = BeemoHelperFrame:CreateFontString(nil, "ARTWORK", "GameTooltipTextSmall");
		BeemoHelperFrame.HPTip:SetAllPoints( BeemoHelperFrame)
		BeemoHelperFrame.HPTip:SetTextColor(1,1,0)
		BeemoHelperFrame.HPTip:SetText(L["Not Setting"])

		BeemoHelperFrame:SetScript("OnReceiveDrag",function()
			if InCombatLockdown() then
				print(L["CannotModifySpellInCombat"])
				ClearCursor()
				return
			end
			
			local ret={GetCursorInfo()}
			if ret[1]=="spell" then
				local dragtype,spellIndex, bookType, spellID=ret[1],ret[2],ret[3],ret[4]
				local rank=SpellIDToRank[spellID]
				
				if rank then
					rank="("..L["Rank"].." "..rank..")"
				else
					rank=""
				end
				local spellName=GetSpellInfo(spellID)
				local guid,playername = UnitGUID("target"), UnitName("target")
				local classFilename, classId = UnitClassBase("target")
				
				
				--DPrint(playername,guid,classId,spellID,rank)
				if guid and spellName then
					local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid);
					if type=="Player" then
						--print("/cast "..'[@"' .. playername .. '",help,nodead] '..spellName..rank)
						BeemoHelperFrame.playername=playername
						BeemoHelperFrame.playerid=guid		

						BeemoHelperFrame:SetAttribute("macrotext1", "/cast ".."[@" .. playername .. ",help,nodead] "..spellName..rank)
						BeemoHelperFrame.TipText=("%s%s|r\n%s"):format(make_class_prefix(classId),BeemoHelperFrame.playername,spellName..rank)
						BeemoHelperFrame.HPTip:SetText(BeemoHelperFrame.TipText)
						BeemoHelper:UNIT_HEALTH("UNIT_HEALTH","target")
						--BeemoHelperFrame.HPTip:SetText(BeemoHelperFrame.playername.."\n"..spellName..rank)
						ClearCursor()
					end
				else
					BeemoHelperFrame.playername=nil
					BeemoHelperFrame.playerid=nil
					BeemoHelperFrame.TipText=""
					
					BeemoHelperFrame:SetAttribute("macro",'/script print("'..L["HelpTips"]..'")') 
					BeemoHelperFrame.HPTip:SetText(L["Not Setting"])
					if BeemoHelperMask then
						BeemoHelperMask.bar:SetValue(0)
					end
					ClearCursor()
				end
			end
		end)	
		BeemoHelperFrame:Hide()
	end	

--Mask Frame
	if not BeemoHelperMask then
		BeemoHelperMask=CreateFrame("frame",nil)
		BeemoHelperMask:SetFrameLevel(2)
		BeemoHelperMask:SetSize(100,60)
		BeemoHelperMask.maskbg=BeemoHelperMask:CreateTexture(nil,"ARTWORK", nil,1)
		BeemoHelperMask:EnableMouse(false)
		BeemoHelperMask.maskbg:SetTexture(texture_str)
		BeemoHelperMask.maskbg:SetVertexColor(0.8,0.1,0.1,0.0)
		BeemoHelperMask.maskbg:SetAllPoints(BeemoHelperMask)

		local border_texture_str = "Interface\\Tooltips\\UI-StatusBar-Border"	
		
		local border_texture1=BeemoHelperMask:CreateTexture(nil,"BORDER")
		
		border_texture1:SetPoint("TOPLEFT",-3,3)
		border_texture1:SetSize(96,16)
		border_texture1:SetTexture(border_texture_str)
		BeemoHelperMask.bar=CreateFrame("StatusBar",nil,BeemoHelperMask)
		BeemoHelperMask.bar:SetMinMaxValues(0,100)
		BeemoHelperMask.bar:SetValue(0)
		BeemoHelperMask.bar:SetStatusBarTexture(texture_str,"BACKGROUND", nil,3)
		BeemoHelperMask.bar:SetStatusBarColor(0.1,0.8,0,0.85)
		BeemoHelperMask.bar:SetSize(90,10)
		BeemoHelperMask.bar:SetPoint("TOPLEFT",BeemoHelperMask,"TOPLEFT",0,0)
		BeemoHelperMask:SetAllPoints(BeemoHelperFrame)

		
	end
	BeemoHelperMask:Hide()
end

function BeemoHelper:Toggle(force)
	if InCombatLockdown() then
		print(L["CannotModifyInCombat"])
		return
	end
	if self:IsEnabled() and force~="Enable" then
		self:Disable()
	elseif (not self:IsEnabled()) and force~="Disable" then
		self:Enable()
	end
end

function BeemoHelper:SetupDataBroker()
    local LDB = LibStub('LibDataBroker-1.1')
     local BeemoHelperLauncher = LDB:NewDataObject('BeemoHelper', {
        type = 'launcher',
		icon = "Interface\\Icons\\INV_Mace_15",
		label = L["BeemoHelper_TOGGLE_TEXT"],
        OnClick = function()
            return self:Toggle()
        end,
		OnTooltipShow = function(tt)
			tt:AddLine(L["BeemoHelper_TOGGLE_TEXT"])
		end,
        OnLeave = GameTooltip_Hide,
    })

     LibStub('LibDBIcon-1.0'):Register('BeemoHelper', BeemoHelperLauncher,{ 
		hide = false,
		radius = 110,
	})
end

--event and stuff
local function parseGUID(gid)
	if gid==nil then
		return nil,nil
	end
	local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-", gid or "")
	return npc_id,spawn_uid
end

-- enable heal on click
function BeemoHelper:stopHeal()
	BeemoHelperMask.maskbg:SetVertexColor(0.8,0.1,0.1,0.6)
	BeemoHelperMask:EnableMouse(true) 
end
	
-- disable heal on click
function BeemoHelper:startHeal()
	BeemoHelperMask.maskbg:SetVertexColor(0.1,0.1,0.1,0.0)
	PlaySound(5275)
	BeemoHelperMask:EnableMouse(false)
end
	
	
function BeemoHelper:CombatLogEvent(timestamp, eventtype, hideCaster, srcGUID, srcName, srcFlags, srcRaidFlags, dstGUID, dstName, dstFlags, dstRaidFlags, ...)
	local direct_damage = {["SWING_DAMAGE"]=1,["RANGE_DAMAGE"]=4,["SPELL_DAMAGE"]=4,["SPELL_PERIODIC_DAMAGE"]=4,["DAMAGE_SPLIT"]=4}
	local npc_id,spawn_uid = parseGUID(dstGUID)
	local do_damage = 0
	if BeemoHelperFrame.playerid~=nil and BeemoHelperFrame.playerid==dstGUID then

		--enable for 1s after hateful
		if eventtype=="SPELL_DAMAGE" then
			local data={...}
			if (data[2]=="Hateful Strike" or data[2] == "Frostbolt") then
				self:startHeal()
				
				C_Timer.After(1, function() 
					--DPrint(GetTime(),":","Disable")
					BeemoHelperMask.maskbg:SetVertexColor(0.8,0.1,0.1,0.6)
					BeemoHelperMask:EnableMouse(true) 
					end)
			end
	
		end		

	end
	
end

function BeemoHelper:UNIT_HEALTH(event,uid)
	if BeemoHelperFrame.playerid~=nil and BeemoHelperFrame.playerid==UnitGUID(uid) and BeemoHelperMask.bar then
			local health_rate=UnitHealth(uid)*100/UnitHealthMax(uid)
			if health_rate<=30 then
				BeemoHelperMask.bar:SetStatusBarColor(0.8,0.1,0,0.85)
			elseif health_rate<=70 then
				BeemoHelperMask.bar:SetStatusBarColor(0.7,0.7,0,0.85)
			else
				BeemoHelperMask.bar:SetStatusBarColor(0.1,0.8,0,0.85)
			end
			BeemoHelperMask.bar:SetValue(UnitHealth(uid)*100/UnitHealthMax(uid))
	end
end

function BeemoHelper:COMBAT_LOG_EVENT_UNFILTERED()
	BeemoHelper:CombatLogEvent(CombatLogGetCurrentEventInfo())
end

function BeemoHelper:PLAYER_REGEN_ENABLED()
	self:startHeal()
end

function BeemoHelper:PLAYER_REGEN_DISABLED()
	self:stopHeal()
end

function BeemoHelper:OnInitialize()
	self:BuildFrame()
	self:SetEnabledState(false)
	self:SetupDataBroker()
	self:Print(L["LoadInfo"])
end

function BeemoHelper:OnEnable()
	--DPrint("Enable")
	if BeemoHelperFrame then
		BeemoHelperFrame:Show()
		BeemoHelperMask:Show()
		self:Print(SELECTED_CHAT_FRAME,L["ShowBeemoHelper"])
		self.timerCount=0 
		BeemoHelper.Active=true				
		BeemoHelper:RegisterEvent("UNIT_HEALTH")
		BeemoHelper:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		BeemoHelper:RegisterEvent("PLAYER_REGEN_ENABLED")
		BeemoHelper:RegisterEvent("PLAYER_REGEN_DISABLED")
	end

end

function BeemoHelper:OnDisable()
	--DPrint("Disable")
	if BeemoHelperFrame then
		BeemoHelperFrame:Hide()
		BeemoHelperMask:Hide()
		BeemoHelperMask:EnableMouse(false)
		self:Print(SELECTED_CHAT_FRAME,L["HideBeemoHelper"])
		BeemoHelper.Active=false
		BeemoHelper:UnregisterEvent("UNIT_HEALTH")
		BeemoHelper:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		BeemoHelper:UnregisterEvent("PLAYER_REGEN_ENABLED")
		BeemoHelper:UnregisterEvent("PLAYER_REGEN_DISABLED")
	end
	
end

